// MiniAUXlib by Martin J. Fiedler <KeyJ@s2000.ws>
// only consists of an AUXlib-style BMP format texture loader
// really dirty code -- DO NOT USE on little-endian platforms!!!1

#ifndef _MINIAUX_H
#define _MINIAUX_H

// uncomment the following to load BMP files right, i.e. not flipped
// a stupid bug in AUXlib causes bitmaps to be loaded bottom-up,
// which is emulated by miniAUXlib by default
//#define FLIP_BITMAPS

#include <stdio.h>
#include <stdlib.h>

typedef struct _AUX_RGBImageRec {
    int sizeX, sizeY;
    unsigned char *data;
} AUX_RGBImageRec;

#pragma pack(1)
typedef struct _bmpheader {
  char id1,id2;
  int filesize;
  int reserved;
  int data_offset;
  int headersize;
  int width;
  int height;
  short planes;
  short bpp;
  int compr;
  int data_size;
  int hres;
  int vres;
  int colors;
  int icolors;
  int palette[256];
} bmpheader;
#pragma pack(4)

AUX_RGBImageRec *auxDIBImageLoad(char* filename) {
  FILE *f;
  bmpheader head;
  AUX_RGBImageRec *rec;
  unsigned char *scanbuf;
  int scanlen;
  int x,y,i;
  unsigned char r,g,b;
  unsigned char *src,*dest;

  f=fopen(filename,"rb");
  if(!f) return NULL;
  fread(&head,1,sizeof(head),f);
  if(head.id1!='B' || head.id2!='M') {
    fclose(f);
    return NULL;
  }
  fseek(f,head.data_offset,SEEK_SET);
  if(head.bpp==8) {
    rec=(AUX_RGBImageRec*)malloc(sizeof(AUX_RGBImageRec));
    rec->sizeX=head.width;
    rec->sizeY=head.height;
    rec->data=(unsigned char*)malloc(head.width*head.height*3);
    scanlen=(head.width+3)&0x7FFC;
    scanbuf=(unsigned char*)malloc(scanlen);
#ifdef FLIP_BITMAPS
    for(y=head.height-1; y>=0; --y) {
#else
    for(y=0; y<head.height; ++y) {
#endif
      fread(scanbuf,1,scanlen,f);
      src=scanbuf;
      dest=&rec->data[y*head.width*3];
      for(x=head.width; x>0; --x) {
        i=head.palette[*src++];
        *dest++=(i>>16)&0xFF;
        *dest++=(i>> 8)&0xFF;
        *dest++= i     &0xFF;
      }
    }
    free(scanbuf);
  } else if(head.bpp==24) {
    rec=(AUX_RGBImageRec*)malloc(sizeof(AUX_RGBImageRec));
    rec->sizeX=head.width;
    rec->sizeY=head.height;
    rec->data=(unsigned char*)malloc(head.width*head.height*3);
    scanlen=(head.width*3+3)&0x7FFC;
    scanbuf=(unsigned char*)malloc(scanlen);
#ifdef FLIP_BITMAPS
    for(y=head.height-1; y>=0; --y) {
#else
    for(y=0; y<head.height; ++y) {
#endif
      fread(scanbuf,1,scanlen,f);
      src=scanbuf;
      dest=&rec->data[y*head.width*3];
      for(x=head.width; x>0; --x) {
        b=*src++;  g=*src++;  r=*src++;
        *dest++=r; *dest++=g; *dest++=b;
      }
    }
    free(scanbuf);
  } else {
    fclose(f);
    return NULL;
  }
  fclose(f);
  return rec;
}

#endif
